import csv

title = ['name', 'age']
d1 = ['小明', 20]
d2 = ['小红', '21']
dicts = [title, d1, d2]

# 一行一行写
file_name = 'name2.csv'
with open(file_name, 'w', newline='') as f:
    writer = csv.writer(f)
    writer.writerow(title)
    writer.writerow(d1)

# 一次全写出去
file_name = 'name3.csv'
with open(file_name, 'w', newline='') as f:
    writer = csv.writer(f)
    writer.writerows(dicts)

# 使用字典写
file_name = 'name4.csv'
with open(file_name, 'w', newline='') as f:
    fieldnames = ['first_name', 'last_name']
    writer = csv.DictWriter(f, fieldnames=fieldnames)

    writer.writeheader()
    writer.writerow({'first_name': 'Baked', 'last_name': 'Beans'})
    writer.writerow({'first_name': 'Lovely', 'last_name': 'Spam'})
    writer.writerow({'first_name': 'Wonderful', 'last_name': 'Spam'})
