import csv

# 第1种
file_name = 'name.csv'
with open(file_name, newline='') as f:
    reader = csv.reader(f, dialect='excel')
    header_row = next(reader)
    for index, column_header in enumerate(header_row):
        print(index, column_header)

    names, ages, sexs = [], [], []
    for row in reader:
        names.append(row[0])
        ages.append(int(row[1]))
        sexs.append(row[2])

    print(names)
    print(ages)
    print(sexs)

    print('-------------------')
# 第2种 将每行中的信息映射到一个 dict
with open(file_name, newline='') as f:
    reader = csv.DictReader(f)
    for row in reader:
        print(row)
        print(row['name'])
